# !/usr/bin/env python
# encoding:utf-8

import requests
import sys
import templates

HOST = 'http://dict.youdao.com/'
PATH = 'jsonapi?client=mobile&le=eng&q='
DICT_PARAM = "&dicts={'count':20,'dicts':[['ec','ce'],['ec21'],['ce_new'],['ee'],['hh'],['collins'],['special'],['phrs'],['syno'],['rel_word'],['pic_dict'],['fanyi'],['web_search'],['typos'],['web_trans'],['blng_sents_part'],['media_sents_part'],['auth_sents_part'],['baike']]}"


def main():
    url = HOST + PATH + sys.argv[1] + DICT_PARAM
    response = requests.get(url).json()
    print get_simple_dict(response)
    print get_youdao_dict(response)
    print get_collins_dict(response)


def get_simple_dict(res):
    simple = res.get("simple")
    word = simple.get("query")
    uk = simple.get("word")[0].get("ukphone")
    us = simple.get("word")[0].get("usphone")
    return templates.simple_dict(word=word, uk=uk, us=us)


def get_youdao_dict(res):
    youdao = res.get("ec")
    name = youdao.get("source").get("name")
    translations = youdao.get("word")[0].get("trs")
    return templates.youdao_dict(name=name, translations=translations)


def get_collins_dict(res):
    collins = res.get("collins")
    name = u"柯林斯英汉双解大词典"
    entries = collins.get("collins_entries")[0].get("entries").get("entry")
    return templates.collins_dict(name=name, entries=entries)

if __name__ == '__main__':
    main()
