# !/usr/bin/env python
# encoding:utf-8
import color

TITLE_BAR_LENGTH = 40


def simple_dict(word, uk, us):
    return color.BOLD + word.upper() + color.ENDC + "\n" + \
           color.RED + "uk" + color.ENDC + " /" + uk + "/  " + \
           color.RED + "us" + color.ENDC + " /" + us + "/"


def youdao_dict(name, translations):
    return title_bar(name) + \
           "\n".join(map(lambda tr: tr.get("tr")[0].get("l").get("i")[0], translations))


def collins_dict(name, entries):
    return title_bar(name) + \
           "\n".join(map(formate_collins, entries))


def formate_collins(entry):
    tran_entry = entry.get("tran_entry")[0]
    pos_entry = color.YELLOW + tran_entry.get("pos_entry").get("pos").lower() + color.ENDC
    translation = tran_entry.get("tran")
    eng_sent = tran_entry.get("exam_sents").get("sent")[0].get("eng_sent")
    chn_sent = tran_entry.get("exam_sents").get("sent")[0].get("chn_sent")
    return pos_entry + " " + translation + "\n" + "eg. ".rjust(4) + eng_sent.rjust(4) + "\n" + chn_sent.rjust(8)


def title_bar(name):
    length = TITLE_BAR_LENGTH - len(name)
    return color.LIGHT_PURPLE + "========" + format(name, '=^' + str(length) + 's') + "========\n" + color.ENDC
